Index: /branches/HTM-10.0-dev0/cfg/MV-HEVC/fullCfg.cfg
===================================================================
--- /branches/HTM-10.0-dev0/cfg/MV-HEVC/fullCfg.cfg	(revision 853)
+++ /branches/HTM-10.0-dev0/cfg/MV-HEVC/fullCfg.cfg	(revision 854)
@@ -31,15 +31,22 @@
 #======== VPS/ Layer sets ================
 VpsNumLayerSets               : 4            # Number of layer sets    
-LayerIdsInSet_0               : 0            # LayerIds of Layer set
-LayerIdsInSet_1               : 0 1          # LayerIds of Layer set
-LayerIdsInSet_2               : 0 2          # LayerIds of Layer set
-LayerIdsInSet_3               : 0 1 2        # LayerIds of Layer set
+LayerIdsInSet_0               : 0            # Indices in VPS of layers in layer set 0
+LayerIdsInSet_1               : 0 1          # Indices in VPS of layers in layer set 1
+LayerIdsInSet_2               : 0 2          # Indices in VPS of layers in layer set 2
+LayerIdsInSet_3               : 0 1 2        # Indices in VPS of layers in layer set 3
 
-DefaultOneTargetOutputLayerFlag: 0           # Output highest layer of layer sets by default
-OutputLayerSetIdx             : 1 2          # Indices of layer sets used as additional output layer sets
-LayerIdsInAddOutputLayerSet_0 : 1            # LayerIds of additional output layers
-LayerIdsInAddOutputLayerSet_0 : 1            # LayerIds of additional output layers
+DefaultTargetOutputLayerIdc   : 0            # Specifies output layers of layer sets, 0: output all layers, 1: output highest layer, 2: specified by LayerIdsInDefOutputLayerSet
+LayerIdsInDefOutputLayerSet_0 :              # Indices in VPS of output layers in layer set 0 (when DefaultTargetOutputLayerIdc is equal to 2)
+LayerIdsInDefOutputLayerSet_1 :              # Indices in VPS of output layers in layer set 1 (when DefaultTargetOutputLayerIdc is equal to 2)
+LayerIdsInDefOutputLayerSet_2 :              # Indices in VPS of output layers in layer set 2 (when DefaultTargetOutputLayerIdc is equal to 2)
+LayerIdsInDefOutputLayerSet_3 :              # Indices in VPS of output layers in layer set 3 (when DefaultTargetOutputLayerIdc is equal to 2)
+
+
+OutputLayerSetIdx             : 1 2          # Indices of layer sets used to derive additional output layer sets
+LayerIdsInAddOutputLayerSet_0 : 1            # Indices in VPS of output layers in additional output layer set 0
+LayerIdsInAddOutputLayerSet_1 : 2            # Indices in VPS of output layers in additional output layer set 1
+
+
 ProfileLevelTierIdx           : 0 0 0 0      # Indices to profile level tier (TBD)
-
 #======== Unit definition ================
 MaxCUWidth                    : 64          # Maximum coding unit width in pixel
Index: /branches/HTM-10.0-dev0/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- /branches/HTM-10.0-dev0/source/App/TAppDecoder/TAppDecTop.cpp	(revision 853)
+++ /branches/HTM-10.0-dev0/source/App/TAppDecoder/TAppDecTop.cpp	(revision 854)
@@ -140,5 +140,7 @@
     AOF( m_pScaleOffsetFile ); 
   }
+#if !FIX_CAM_PARS_COLLECTOR
   m_cCamParsCollector.init( m_pScaleOffsetFile );
+#endif
 #endif
   InputByteStream bytestream(bitstreamFile);
@@ -207,5 +209,16 @@
       read(nalu, nalUnit);
 #if H_MV      
+#if H_MV_FIX_VPS_LAYER_ID_NOT_EQUAL_ZERO
+      if( (m_iMaxTemporalLayer >= 0 && nalu.m_temporalId > m_iMaxTemporalLayer) 
+          || !isNaluWithinTargetDecLayerIdSet(&nalu)
+          || nalu.m_layerId > MAX_NUM_LAYER_IDS-1
+          || (nalu.m_nalUnitType == NAL_UNIT_VPS && nalu.m_layerId > 0)           
+#if H_MV_HLS_7_MISC_P0130_EOS
+          || (nalu.m_nalUnitType == NAL_UNIT_EOB && nalu.m_layerId > 0)           
+#endif
+         ) 
+#else
       if( (m_iMaxTemporalLayer >= 0 && nalu.m_temporalId > m_iMaxTemporalLayer) || !isNaluWithinTargetDecLayerIdSet(&nalu) || nalu.m_layerId > MAX_NUM_LAYER_IDS-1 ) 
+#endif
       {
         bNewPicture = false;
@@ -235,6 +248,23 @@
           }
 
+#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
+          if ( m_targetOptLayerSetIdx < 0 || m_targetOptLayerSetIdx >= vps->getNumOutputLayerSets() )
+          {
+            fprintf(stderr, "\ntarget output layer set index must be in the range of 0 to %d, inclusive \n", vps->getNumOutputLayerSets() - 1 );            
+            exit(EXIT_FAILURE);
+          }
+#endif
           m_targetDecLayerIdSet = vps->getTargetDecLayerIdList( m_targetOptLayerSetIdx ); 
         }
+
+#if FIX_CAM_PARS_COLLECTOR
+#if H_3D
+        if (nalu.m_nalUnitType == NAL_UNIT_VPS )
+        {        
+          
+          m_cCamParsCollector.init( m_pScaleOffsetFile, m_tDecTop[decIdx]->getPrefetchedVPS() );
+        }       
+#endif
+#endif
         bNewPicture       = ( newSliceDiffLayer || newSliceDiffPoc ) && !sliceSkippedFlag; 
         if ( nalu.isSlice() && firstSlice && !sliceSkippedFlag )        
Index: /branches/HTM-10.0-dev0/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- /branches/HTM-10.0-dev0/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 853)
+++ /branches/HTM-10.0-dev0/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 854)
@@ -388,7 +388,17 @@
   ("VpsNumLayerSets",       m_vpsNumLayerSets    , 1                    , "Number of layer sets")    
   ("LayerIdsInSet_%d",      m_layerIdsInSets     , std::vector<Int>(1,0), MAX_VPS_OP_SETS_PLUS1 ,"LayerIds of Layer set")  
+#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
+  ("DefaultTargetOutputLayerIdc"     , m_defaultTargetOutputLayerIdc     , 0, "Specifies output layers of layer sets, 0: output all layers, 1: output highest layer, 2: specified by LayerIdsInDefOutputLayerSet")
+#else
   ("DefaultOneTargetOutputLayerFlag"  , m_defaultOneTargetOutputLayerIdc  , 0, "Output highest layer of layer sets by default")
+#endif
   ("OutputLayerSetIdx",     m_outputLayerSetIdx  , std::vector<Int>(0,0), "Indices of layer sets used as additional output layer sets")  
+
+#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
+  ("LayerIdsInAddOutputLayerSet_%d", m_layerIdsInAddOutputLayerSet      , std::vector<Int>(0,0), MAX_VPS_ADD_OUTPUT_LAYER_SETS, "Indices in VPS of output layers in additional output layer set")  
+  ("LayerIdsInDefOutputLayerSet_%d", m_layerIdsInDefOutputLayerSet      , std::vector<Int>(0,0), MAX_VPS_OP_SETS_PLUS1, "Indices in VPS of output layers in layer set")  
+#else
   ("LayerIdsInAddOutputLayerSet_%d", m_layerIdsInAddOutputLayerSet      , std::vector<Int>(1,0), MAX_VPS_ADD_OUTPUT_LAYER_SETS, "LayerIds of additional output layers")  
+#endif
   ("ProfileLevelTierIdx",   m_profileLevelTierIdx, std::vector<Int>(1,0), "Indices to profile level tier")
   
@@ -604,9 +614,14 @@
 
   // DBP Size
+#if !H_MV_HLS_7_FIX_SET_DPB_SIZE
   ("SubLayerFlagInfoPresentFlag",  m_subLayerFlagInfoPresentFlag , false                                           , "SubLayerFlagInfoPresentFlag")
+#endif
   // VPS VUI
   ("VpsVuiPresentFlag"           , m_vpsVuiPresentFlag           , false                                           , "VpsVuiPresentFlag           ")
   ("CrossLayerPicTypeAlignedFlag", m_crossLayerPicTypeAlignedFlag, false                                           , "CrossLayerPicTypeAlignedFlag")  // Could actually be derived by the encoder
   ("CrossLayerIrapAlignedFlag"   , m_crossLayerIrapAlignedFlag   , false                                           , "CrossLayerIrapAlignedFlag   ")  // Could actually be derived by the encoder
+#if H_MV_HLS_7_MISC_P0068_21
+  ("AllLayersIdrAlignedFlag"     , m_allLayersIdrAlignedFlag     , false                                           , "CrossLayerIrapAlignedFlag   ")  // Could actually be derived by the encoder
+#endif
   ("BitRatePresentVpsFlag"       , m_bitRatePresentVpsFlag       , false                                           , "BitRatePresentVpsFlag       ")
   ("PicRatePresentVpsFlag"       , m_picRatePresentVpsFlag       , false                                           , "PicRatePresentVpsFlag       ")
@@ -1408,5 +1423,38 @@
   }
 
+#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
+  xConfirmPara( m_defaultTargetOutputLayerIdc < 0 || m_defaultTargetOutputLayerIdc > 2, "Default target output layer idc must greater than or equal to 0 and less than or equal to 2." );  
+
+  if( m_defaultTargetOutputLayerIdc != 2 )
+  {
+    Bool anyDefaultOutputFlag = false;   
+    for (Int lsIdx = 0; lsIdx < m_vpsNumLayerSets; lsIdx++)
+    { 
+      anyDefaultOutputFlag = anyDefaultOutputFlag || ( m_layerIdsInDefOutputLayerSet[lsIdx].size() != 0 );
+    }    
+    printf( "\nWarning: Ignoring LayerIdsInDefOutputLayerSet parameters, since defaultTargetOuputLayerIdc is not equal 2.\n" );    
+  }
+  else  
+  {  
+    for (Int lsIdx = 0; lsIdx < m_vpsNumLayerSets; lsIdx++)
+    { 
+      for (Int i = 0; i < m_layerIdsInDefOutputLayerSet[ lsIdx ].size(); i++)
+      {
+        Bool inLayerSetFlag = false; 
+        for (Int j = 0; j < m_layerIdsInSets[ lsIdx].size(); j++ )
+        {
+          if ( m_layerIdsInSets[ lsIdx ][ j ] == m_layerIdsInDefOutputLayerSet[ lsIdx ][ i ] )
+          {
+            inLayerSetFlag = true; 
+            break; 
+          }        
+        }
+        xConfirmPara( !inLayerSetFlag, "All output layers of a output layer set must be included in corresponding layer set.");
+      }
+    }
+  }
+#else
   xConfirmPara( m_defaultOneTargetOutputLayerIdc < 0 || m_defaultOneTargetOutputLayerIdc > 1, "Default one target output layer idc must be equal to 0 or equal to 1" );
+#endif
   xConfirmPara( m_profileLevelTierIdx.size() < m_vpsNumLayerSets + m_outputLayerSetIdx.size(), "The number of Profile Level Tier indices must be equal to the number of layer set plus the number of output layer set indices" );
 
Index: /branches/HTM-10.0-dev0/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- /branches/HTM-10.0-dev0/source/App/TAppEncoder/TAppEncCfg.h	(revision 853)
+++ /branches/HTM-10.0-dev0/source/App/TAppEncoder/TAppEncCfg.h	(revision 854)
@@ -89,7 +89,14 @@
   Int                    m_vpsNumLayerSets;                   ///< Number of layer sets
   std::vector< std::vector<Int> > m_layerIdsInSets;           ///< LayerIds in vps of layer set 
+#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
+  Int                    m_defaultTargetOutputLayerIdc;       ///< Specifies output layers of layer sets, 0: output all layers, 1: output highest layers, 2: specified by LayerIdsInDefOuputLayerSet
+#else
   Int                    m_defaultOneTargetOutputLayerIdc;    ///< Output highest layer of layer sets by default when equal to 1
+#endif
   std::vector<Int>       m_outputLayerSetIdx;                 ///< Indices of layer sets used as additional output layer sets  
   std::vector< std::vector<Int> > m_layerIdsInAddOutputLayerSet; ///< LayerIds in vps of additional output layers
+#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
+  std::vector< std::vector<Int> > m_layerIdsInDefOutputLayerSet; ///< Indices in vps of output layers in layer sets
+#endif
   std::vector<Int>       m_profileLevelTierIdx;               ///< Indices of of profile level tier
   
@@ -99,5 +106,7 @@
 
   // DBP Size
+#if !H_MV_HLS_7_FIX_SET_DPB_SIZE
   Bool m_subLayerFlagInfoPresentFlag;
+#endif
 
   // VPS VUI
@@ -105,4 +114,7 @@
   Bool m_crossLayerPicTypeAlignedFlag;
   Bool m_crossLayerIrapAlignedFlag;
+#if H_MV_HLS_7_MISC_P0068_21
+  Bool m_allLayersIdrAlignedFlag;
+#endif
   Bool m_bitRatePresentVpsFlag;
   Bool m_picRatePresentVpsFlag;
Index: /branches/HTM-10.0-dev0/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- /branches/HTM-10.0-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 853)
+++ /branches/HTM-10.0-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 854)
@@ -127,4 +127,7 @@
   xSetRepFormat            ( vps ); 
   xSetLayerSets            ( vps ); 
+#if H_MV_HLS_7_FIX_SET_DPB_SIZE
+  xSetDpbSize              ( vps ); 
+#endif
   xSetVPSVUI               ( vps ); 
 #if H_3D
@@ -1491,4 +1494,75 @@
 }
 
+#if H_MV_HLS_7_FIX_SET_DPB_SIZE
+Void TAppEncTop::xSetDpbSize                ( TComVPS& vps )
+{
+  // These settings need to be verified
+
+  TComDpbSize* dpbSize = vps.getDpbSize(); 
+
+  assert ( dpbSize != 0 ); 
+
+  for( Int i = 1; i < vps.getNumOutputLayerSets(); i++ )
+  {  
+    std::vector<Int> targetDecLayerIdList = vps.getTargetDecLayerIdList( i ); 
+    Bool subLayerFlagInfoPresentFlag = false; 
+
+#if H_MV_HLS_7_HRD_P0156_7
+    for( Int j = 0; j  <=  vps.getMaxSubLayersInLayerSetMinus1( i ); j++ )
+#else
+    for( Int j = 0; j  <=  vps.getMaxTLayers() - 1 ; j++ )
+#endif
+    {   
+      Bool subLayerDpbInfoPresentFlag = false; 
+#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
+      assert( vps.getNumSubDpbs( vps.getLayerSetIdxForOutputLayerSet( i ) ) == targetDecLayerIdList.size() ); 
+      for( Int k = 0; k < vps.getNumSubDpbs( vps.getLayerSetIdxForOutputLayerSet( i )); k++ )   
+#else
+      assert( vps.getNumSubDpbs( vps.getOutputLayerSetIdxMinus1( i ) + 1 ) == targetDecLayerIdList.size() ); 
+      for( Int k = 0; k < vps.getNumSubDpbs( vps.getOutputLayerSetIdxMinus1( i ) + 1 ); k++ )   
+#endif
+      {
+        Int layerIdInVps = vps.getLayerIdInVps( targetDecLayerIdList[k] );           
+#if H_MV_HLS7_GEN
+        // TBD. Some derivation based on output layer set might be added here. 
+#endif
+        dpbSize->setMaxVpsDecPicBufferingMinus1( i, k, j, m_maxDecPicBufferingMvc[ layerIdInVps ][ j ] - 1 );
+        if ( j > 0 )
+        {
+          subLayerDpbInfoPresentFlag = subLayerDpbInfoPresentFlag || ( dpbSize->getMaxVpsDecPicBufferingMinus1( i, k, j ) != dpbSize->getMaxVpsDecPicBufferingMinus1( i, k, j - 1 ) );
+        }
+      }        
+
+      Int maxNumReorderPics = MIN_INT;
+      for ( Int idx = 0; idx < targetDecLayerIdList.size(); idx++ )
+      {
+        Int layerIdInVps = vps.getLayerIdInVps( targetDecLayerIdList[ idx ] ); 
+        maxNumReorderPics = std::max( maxNumReorderPics, m_numReorderPicsMvc[ layerIdInVps ][ j ] ); 
+      }
+      assert( maxNumReorderPics != MIN_INT ); 
+
+      dpbSize->setMaxVpsNumReorderPics( i, j, maxNumReorderPics );
+      if ( j > 0 )
+      {
+        subLayerDpbInfoPresentFlag = subLayerDpbInfoPresentFlag || ( dpbSize->getMaxVpsNumReorderPics( i, j ) != dpbSize->getMaxVpsNumReorderPics( i, j - 1 ) );
+      }
+
+      // To Be Done !
+      // dpbSize->setMaxVpsLatencyIncreasePlus1( i, j, xx );
+      if ( j > 0 )
+      {
+        subLayerDpbInfoPresentFlag = subLayerDpbInfoPresentFlag || ( dpbSize->getMaxVpsLatencyIncreasePlus1( i, j ) != dpbSize->getMaxVpsLatencyIncreasePlus1( i, j - 1  ) );
+      }
+
+      if( j > 0 )  
+      {
+        dpbSize->setSubLayerDpbInfoPresentFlag( i, j, subLayerDpbInfoPresentFlag );
+        subLayerFlagInfoPresentFlag = subLayerFlagInfoPresentFlag || subLayerDpbInfoPresentFlag; 
+      }       
+    }  
+    dpbSize->setSubLayerFlagInfoPresentFlag( i, subLayerFlagInfoPresentFlag ); 
+  }  
+}
+#else
 Void TAppEncTop::xSetDpbSize                ( TComVPS& vps )
 {
@@ -1503,5 +1577,4 @@
     std::vector<Int> targetDecLayerIdList = vps.getTargetDecLayerIdList( i ); 
     dpbSize->setSubLayerFlagInfoPresentFlag( i, m_subLayerFlagInfoPresentFlag );
-
     if ( dpbSize->getSubLayerFlagInfoPresentFlag( i ) )
     {
@@ -1546,5 +1619,5 @@
   }  
 }
-
+#endif
 
 Void TAppEncTop::xSetLayerSets( TComVPS& vps )
@@ -1552,5 +1625,7 @@
   // Layer sets
   vps.setVpsNumLayerSetsMinus1   ( m_vpsNumLayerSets - 1 ); 
+#if !H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
   vps.setVpsNumberLayerSetsMinus1( vps.getVpsNumLayerSetsMinus1() ); 
+#endif
     
   for (Int lsIdx = 0; lsIdx < m_vpsNumLayerSets; lsIdx++ )
@@ -1569,10 +1644,65 @@
   Int numAddOuputLayerSets = (Int) m_outputLayerSetIdx.size(); 
   // Additional output layer sets + profileLevelTierIdx
+#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
+  vps.setDefaultTargetOutputLayerIdc      ( m_defaultTargetOutputLayerIdc );   
+  vps.setNumAddOutputLayerSets            ( numAddOuputLayerSets          ); 
+  vps.initTargetLayerIdLists(); 
+#else
   vps.setDefaultOneTargetOutputLayerIdc   ( m_defaultOneTargetOutputLayerIdc ); 
   vps.setMoreOutputLayerSetsThanDefaultFlag( numAddOuputLayerSets       != 0 );   
   vps.setNumAddOutputLayerSetsMinus1       ( numAddOuputLayerSets - 1        ); 
-
-
-
+#endif
+
+#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
+  for (Int olsIdx = 0; olsIdx < m_vpsNumLayerSets + numAddOuputLayerSets; olsIdx++)
+  {
+    Int addOutLsIdx = olsIdx - m_vpsNumLayerSets;     
+    
+    vps.setOutputLayerSetIdxMinus1( olsIdx, ( ( addOutLsIdx < 0 ) ?  olsIdx  : m_outputLayerSetIdx[ addOutLsIdx ] ) - 1 ); 
+
+    std::vector<Int>& layerIdList    = m_layerIdsInSets[ vps.getLayerSetIdxForOutputLayerSet( olsIdx ) ];
+
+    if (vps.getDefaultTargetOutputLayerIdc() == 2 || addOutLsIdx >= 0 )
+    { 
+      for ( Int i = 0; i < layerIdList.size(); i++)
+      {
+        vps.setOutputLayerFlag( olsIdx, i, ( olsIdx == 0 && i == 0 ) ? vps.inferOutputLayerFlag(olsIdx, i ) : false ); // This is a software only fix for a bug in the spec. In spec outputLayerFlag neither present nor inferred for this case !
+      }
+
+      std::vector<Int>& outLayerIdList = ( addOutLsIdx >= 0 ) ? m_layerIdsInAddOutputLayerSet[addOutLsIdx] : m_layerIdsInDefOutputLayerSet[olsIdx]; 
+
+      Bool outputLayerInLayerSetFlag = false; 
+      for (Int j = 0; j < outLayerIdList.size(); j++)
+      {   
+        for (Int i = 0; i < layerIdList.size(); i++ )
+        {
+          if ( layerIdList[ i ] == outLayerIdList[ j ] )
+          {
+            vps.setOutputLayerFlag( olsIdx, i, true );       
+            outputLayerInLayerSetFlag = true; 
+            break; 
+          }
+        }
+        assert( outputLayerInLayerSetFlag ); // The output layer is not not in the layer set.
+      }
+    }
+    else
+    {
+      for ( Int i = 0; i < layerIdList.size(); i++)
+      {
+        vps.setOutputLayerFlag( olsIdx, i, vps.inferOutputLayerFlag( olsIdx, i ) );       
+      }
+    }
+
+    vps.deriveTargetLayerIdList(  olsIdx ); 
+
+    if ( olsIdx > 0 ) 
+    {
+      vps.setProfileLevelTierIdx( olsIdx, m_profileLevelTierIdx[ olsIdx ] ); 
+    }
+
+    vps.setAltOutputLayerFlag( olsIdx , false);     
+  }
+#else
   for (Int lsIdx = 0; lsIdx < m_vpsNumLayerSets; lsIdx++)
   {
@@ -1612,4 +1742,5 @@
   }
   vps.deriveTargetLayerIdLists(); 
+#endif
 }
 
@@ -1618,10 +1749,16 @@
   vps.setVpsVuiPresentFlag( m_vpsVuiPresentFlag ); 
 
+#if H_MV_HLS_7_FIX_INFER_CROSS_LAYER_IRAP_ALIGNED_FLAG
+  TComVPSVUI* pcVPSVUI = vps.getVPSVUI(  ); 
+  assert( pcVPSVUI ); 
+#endif
+
   if ( m_vpsVuiPresentFlag )
   {
+#if !H_MV_HLS_7_FIX_INFER_CROSS_LAYER_IRAP_ALIGNED_FLAG
     TComVPSVUI* pcVPSVUI = vps.getVPSVUI(  ); 
 
     assert( pcVPSVUI ); 
-
+#endif
 
     // All this stuff could actually be derived by the encoder, 
@@ -1630,5 +1767,7 @@
     pcVPSVUI->setCrossLayerPicTypeAlignedFlag( m_crossLayerPicTypeAlignedFlag );
     pcVPSVUI->setCrossLayerIrapAlignedFlag   ( m_crossLayerIrapAlignedFlag    );
-
+#if H_MV_HLS_7_MISC_P0068_21
+    pcVPSVUI->setAllLayersIdrAlignedFlag     ( m_allLayersIdrAlignedFlag      );
+#endif
     pcVPSVUI->setBitRatePresentVpsFlag( m_bitRatePresentVpsFlag );
     pcVPSVUI->setPicRatePresentVpsFlag( m_picRatePresentVpsFlag );
@@ -1636,5 +1775,9 @@
     if( pcVPSVUI->getBitRatePresentVpsFlag( )  ||  pcVPSVUI->getPicRatePresentVpsFlag( ) )
     {
+#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
+      for( Int i = 0; i  <=  vps.getVpsNumLayerSetsMinus1(); i++ )
+#else
       for( Int i = 0; i  <=  vps.getVpsNumberLayerSetsMinus1(); i++ )
+#endif
       {
         for( Int j = 0; j  <=  vps.getMaxTLayers(); j++ ) 
@@ -1754,4 +1897,10 @@
     pcVPSVUI->setVpsVuiBspHrdPresentFlag( false ); // TBD
   }
+#if H_MV_HLS_7_FIX_INFER_CROSS_LAYER_IRAP_ALIGNED_FLAG
+  else
+  {
+    pcVPSVUI->setCrossLayerIrapAlignedFlag   ( false   );
+  }
+#endif
 }
 #endif
Index: /branches/HTM-10.0-dev0/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- /branches/HTM-10.0-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 853)
+++ /branches/HTM-10.0-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 854)
@@ -103,5 +103,7 @@
 , m_isDepth                       (false)
 #endif
+#if !H_MV_HLS7_GEN
 , m_pocResetFlag                  (false)
+#endif
 #if H_MV
 , m_crossLayerBlaFlag             (false)
@@ -1032,5 +1034,7 @@
 #if H_MV
   // Additional slice header syntax elements 
+#if !H_MV_HLS7_GEN
   m_pocResetFlag               = pSrc->m_pocResetFlag; 
+#endif
   m_discardableFlag            = pSrc->m_discardableFlag; 
   m_interLayerPredEnabledFlag  = pSrc->m_interLayerPredEnabledFlag; 
@@ -1707,11 +1711,15 @@
     }
   } 
-
+#if !H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
   m_vpsNumberLayerSetsMinus1     = -1; 
+#endif
   m_vpsNumProfileTierLevelMinus1 = -1; 
     
+#if !H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
   for ( Int i = 0; i < MAX_VPS_PROFILE_TIER_LEVEL; i++)
   {
+#if !H_MV_HLS_7_VPS_P0048_14
     m_profileRefMinus1[ i ] = -1; 
+#endif
   }
     
@@ -1719,4 +1727,8 @@
   m_numAddOutputLayerSetsMinus1        = -1;   
   m_defaultOneTargetOutputLayerIdc     = 0; 
+#else
+  m_numAddOutputLayerSets              = -1;   
+  m_defaultTargetOutputLayerIdc     = 0; 
+#endif
   
   for ( Int i = 0; i < MAX_VPS_OUTPUTLAYER_SETS; i++)
@@ -1728,6 +1740,11 @@
       m_outputLayerFlag[i][j] = false; 
     }
-  }
+#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
+    m_altOutputLayerFlag[ i ]       = false; 
+#endif
+  }
+#if !H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
   m_altOutputLayerFlag       = false; 
+#endif
   m_maxOneActiveRefLayerFlag = false; 
   m_directDepTypeLenMinus2   = 0;         
@@ -1735,5 +1752,7 @@
 
   m_avcBaseLayerFlag = false;
+#if !H_MV_HLS7_GEN
   m_vpsVuiOffset     = 0; 
+#endif
   m_splittingFlag    = false;
   
@@ -1749,5 +1768,7 @@
   {
     m_vpsProfilePresentFlag   [i] = false;
+#if !H_MV_HLS_7_VPS_P0048_14
     m_profileRefMinus1[i] = 0;
+#endif
     m_outputLayerSetIdxMinus1       [i] = 0;
     for( Int j = 0; j < MAX_VPS_NUH_LAYER_ID_PLUS1; j++ )
@@ -2060,4 +2081,7 @@
 Int    TComVPS::getNumOutputLayerSets() 
 {
+#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
+  return getNumAddOutputLayerSets() + getVpsNumLayerSetsMinus1() + 1; 
+#else
   Int numOutputLayerSets = getVpsNumberLayerSetsMinus1( ) + 1; 
   if ( getMoreOutputLayerSetsThanDefaultFlag( ) )
@@ -2066,4 +2090,5 @@
 }
   return numOutputLayerSets; 
+#endif
 }
 
@@ -2113,8 +2138,29 @@
 }
 
-Void TComVPS::deriveTargetLayerIdLists()
+#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
+Void TComVPS::initTargetLayerIdLists()
 {
   m_targetDecLayerIdLists.resize( getNumOutputLayerSets() ); 
   m_targetOptLayerIdLists.resize( getNumOutputLayerSets() ); 
+}
+
+Void TComVPS::deriveTargetLayerIdList( Int i )
+{  
+  Int lsIdx = getLayerSetIdxForOutputLayerSet( i );     
+  
+  for( Int j = 0; j < getNumLayersInIdList( lsIdx ); j++ )
+  {
+    m_targetDecLayerIdLists[i].push_back( m_layerSetLayerIdList[ lsIdx ][ j ] ); 
+    if( getOutputLayerFlag( i, j  ))
+    {
+      m_targetOptLayerIdLists[i].push_back( m_layerSetLayerIdList[ lsIdx ][ j ] );
+    }
+  }  
+}
+#else
+Void TComVPS::deriveTargetLayerIdLists()
+{
+  m_targetDecLayerIdLists.resize( getNumOutputLayerSets() ); 
+  m_targetOptLayerIdLists.resize( getNumOutputLayerSets() ); 
 
   for (Int targetOptLayerSetIdx = 0; targetOptLayerSetIdx < getNumOutputLayerSets(); targetOptLayerSetIdx++ )
@@ -2133,4 +2179,6 @@
   }
 }
+#endif
+
 #endif // H_MV
 
@@ -2385,4 +2433,12 @@
 {
   m_scalingList = new TComScalingList;
+
+#if H_MV_HLS_7_GEN_P0166_PPS_EXTENSION  
+  for( Int i = 0; i < PS_EX_T_MAX_NUM; i++ ) 
+  {
+    m_ppsExtensionTypeFlag[ i ] = false;
+  }
+#endif
+
 }
 
@@ -2903,4 +2959,7 @@
     // Consider to check here: 
     // "If the current picture is a RADL picture, there shall be no entry in the RefPicSetInterLayer0 and RefPicSetInterLayer1 that is a RASL picture. "    
+#if H_MV_HLS7_GEN
+    // "There shall be no picture that has discardable_flag equal to 1 in RefPicSetInterLayer0 or RefPicSetInterLayer1".    
+#endif
   }
 }
@@ -3077,5 +3136,9 @@
   Int numActiveRefLayerPics; 
 
+#if H_MV_HLS_7_MISC_P0079_18
+  if( getLayerId() == 0 || getNumRefLayerPics() ==  0 )
+#else
   if( getLayerId() == 0 || getVPS()->getNumDirectRefLayers( getLayerId() ) ==  0 )
+#endif
   {
     numActiveRefLayerPics = 0; 
@@ -3091,5 +3154,9 @@
   else if( getVPS()->getMaxOneActiveRefLayerFlag() || getVPS()->getNumDirectRefLayers( getLayerId() ) == 1 )
   {
+#if H_MV_HLS_7_MISC_P0079_18
+    numActiveRefLayerPics = 1; 
+#else
     numActiveRefLayerPics = getRefLayerPicFlag( 0 ) ? 1 : 0; 
+#endif
   }
   else
@@ -3749,4 +3816,7 @@
 {
   m_crossLayerIrapAlignedFlag = true; 
+#if H_MV_HLS_7_MISC_P0068_21
+  m_allLayersIdrAlignedFlag   = false; 
+#endif
   m_bitRatePresentVpsFlag = false;
   m_picRatePresentVpsFlag = false;
@@ -3775,4 +3845,7 @@
       m_minHorizontalCtuOffsetPlus1 [i][j] = -1;
     }
+#if H_MV_HLS_7_MISC_P0182_13
+    m_baseLayerParameterSetCompatibilityFlag[i] = false;
+#endif
   }
   for ( Int i = 0; i < MAX_NUM_VIDEO_SIGNAL_INFO; i++ )
